local shard = Inspect.Shard().name
local context = UI.CreateContext("EZ")
local addonInfo, ezPvP = ...
local ez = ezPvP

ez.UI = {}

local requireUpdate = true
local nkCreateFrame = EnKai.uiCreateFrame
local dialog = UI.CreateContext("EZINPUT")
local icon = UI.CreateContext("EZICON")
local fontSize = 14
local toggle_state = 1
local current_favor = nil
local current_warlord_marks = nil
local current_conquest_marks = nil
local FlashMessageTime = 0

-- Main display window
ez.UI.mainWindow = nkCreateFrame("nkWindowModern", "ez.UI.mainWindow", context)
ez.UI.mainWindow:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 350, 350)
ez.UI.mainWindow:SetLayer(3)
ez.UI.mainWindow:SetVisible(true)
ez.UI.mainWindow:SetWidth(250)
ez.UI.mainWindow:SetHeight(355)
ez.UI.mainWindow:SetTitle("ezPvP Statistics")

-- Main display window
ez.UI.scaleWindow = nkCreateFrame("nkWindowModern", "ez.UI.scaleWindow", context)
ez.UI.scaleWindow:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 350, 350)
ez.UI.scaleWindow:SetLayer(3)
ez.UI.scaleWindow:SetWidth(350)
ez.UI.scaleWindow:SetHeight(100)
ez.UI.scaleWindow:SetTitle("Scale Frame")
ez.UI.scaleWindow:SetVisible(false)

ez.UI.scaleSlider = UI.CreateFrame("RiftSlider", "ez.UI.scaleSlider", ez.UI.scaleWindow)
ez.UI.scaleSlider:SetPoint("CENTER", ez.UI.scaleWindow, "CENTER", 0, 15)
ez.UI.scaleSlider:SetRange(1,2)
ez.UI.scaleSlider:SetLayer(3)


function ez.UI.scaleSlider.Event:SliderChange ()
	if ez.UI.scaleSlider:GetPosition() == 1 then
		ez.UI.rescaleUI("small")
	elseif ez.UI.scaleSlider:GetPosition() == 2 then
		ez.UI.rescaleUI("default")
	else
		ez.UI.rescaleUI("large")
	end
end
ez.UI.dropDownIcon = UI.CreateFrame("Texture", "dropDownIcon", ez.UI.mainWindow)
ez.UI.dropDownIcon:SetTexture("ezPvP", "Libs/enkai/gfx/windowModernArrowDown.png")
ez.UI.dropDownIcon:SetPoint("TOPRIGHT", ez.UI.mainWindow, "TOPRIGHT", -30, 3)
ez.UI.dropDownIcon:SetLayer(10)

function ez.UI.dropDownIcon.Event:LeftClick()
	if ez.UI.dropDown:GetVisible() then
		ez.UI.dropDown:SetVisible(false)
	else
		ez.UI.dropDown:SetVisible(true)
	end
end
ez.UI.dropDown = UI.CreateFrame("Frame", "ez.UI.dropDown", context)
ez.UI.dropDown:SetBackgroundColor(0,0,0,0.95)
ez.UI.dropDown:SetWidth(100)
ez.UI.dropDown:SetHeight(40)
ez.UI.dropDown:SetPoint("TOPRIGHT", ez.UI.mainWindow, "TOPRIGHT", -30, 22)
ez.UI.dropDown:SetLayer(10)
ez.UI.dropDown:SetVisible(false)

	ez.UI.menuItem1 = UI.CreateFrame("Text", "EZ", ez.UI.dropDown)
	ez.UI.menuItem1:SetPoint("TOPLEFT", ez.UI.dropDown, "TOPLEFT", 0, 0)
	ez.UI.menuItem1:SetText("Scale Frame")
	ez.UI.menuItem1:SetLayer(6)
	ez.UI.menuItem1:SetWidth(100)
	ez.UI.menuItem1:SetFontSize(12)
	
	function ez.UI.menuItem1.Event:MouseIn()
		ez.UI.menuItem1:SetBackgroundColor(0.8,0.8,0.8)
		ez.UI.menuItem1:SetFontColor(0,0,0)
	end
	function ez.UI.menuItem1.Event:MouseOut()
		ez.UI.menuItem1:SetBackgroundColor(0.8,0.8,0.8, 0)
		ez.UI.menuItem1:SetFontColor(1,1,1)
	end
	
	function ez.UI.menuItem1.Event:LeftClick()
		ez.UI.scaleWindow:SetVisible(true)
		ez.UI.dropDown:SetVisible(false)
	end
	ez.UI.menuItem2 = UI.CreateFrame("Text", "EZ", ez.UI.dropDown)
	ez.UI.menuItem2:SetPoint("TOPLEFT", ez.UI.dropDown, "TOPLEFT", 0, 20)
	ez.UI.menuItem2:SetText("Close")
	ez.UI.menuItem2:SetLayer(6)
	ez.UI.menuItem2:SetWidth(100)
	ez.UI.menuItem2:SetFontSize(12)
	
	function ez.UI.menuItem2.Event:MouseIn()
		ez.UI.menuItem2:SetBackgroundColor(0.8,0.8,0.8)
		ez.UI.menuItem2:SetFontColor(0,0,0)
	end
	function ez.UI.menuItem2.Event:MouseOut()
		ez.UI.menuItem2:SetBackgroundColor(0.8,0.8,0.8, 0)
		ez.UI.menuItem2:SetFontColor(1,1,1)
	end
	function ez.UI.menuItem2.Event:LeftClick()
		ez.UI.mainWindow:SetVisible(false)
		ez.UI.dropDown:SetVisible(false)
	end
	
-- Minimap Button
local minimapIcon = UI.CreateFrame("Texture", "Icon", icon)
minimapIcon:SetTexture("ezPvP", "icon.png")
minimapIcon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0)
minimapIcon:SetLayer(3)
minimapIcon:SetWidth(32)
minimapIcon:SetHeight(32)

	
ez.UI.goalWindow = nkCreateFrame("nkWindowModern", "ez.UI.goalWindow", dialog)
ez.UI.goalWindow:SetPoint("TOPLEFT", UIParent, "TOPLEFT", UIParent:GetWidth()/2,  UIParent:GetHeight()/2)
ez.UI.goalWindow:SetLayer(3)
ez.UI.goalWindow:SetVisible(false)
ez.UI.goalWindow:SetWidth(250)
ez.UI.goalWindow:SetHeight(180)
ez.UI.goalWindow:SetTitle("ezPvP - Goal")
	
	local goalText = UI.CreateFrame("Text", "EZ", ez.UI.goalWindow)
	goalText:SetPoint("CENTER", ez.UI.goalWindow, "CENTER", 0, -30)
	goalText:SetText("Set your goal for today:")
	goalText:SetLayer(6)
	goalText:SetFontSize(fontSize)
	
	local textField = UI.CreateFrame("RiftTextfield", "EZ", ez.UI.goalWindow)
	textField:SetPoint("CENTER", ez.UI.goalWindow, "CENTER", 0, 7)
	textField:SetLayer(7)
	textField:SetBackgroundColor(0,0,0,1)
	textField:SetWidth(100)
	
	
		
	


local favorLabel = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
favorLabel:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -41, 120)
favorLabel:SetText("Current Favor:")
favorLabel:SetLayer(6)
favorLabel:SetFontSize(fontSize)

	local favorValue = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
	favorValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 65, 120)
	favorValue:SetText("N/A")
	favorValue:SetLayer(6)
	favorValue:SetFontSize(fontSize)

local warlordMarks = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
warlordMarks:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -45, 150)
warlordMarks:SetText("Warlord Marks:")
warlordMarks:SetLayer(6)
warlordMarks:SetFontSize(fontSize)

	local wMarksValue = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
	wMarksValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 65, 150)
	wMarksValue:SetText("N/A")
	wMarksValue:SetLayer(6)
	wMarksValue:SetFontSize(fontSize)

local conquestMarks = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
conquestMarks:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -50, 180)
conquestMarks:SetText("Conquest Marks:")
conquestMarks:SetLayer(6)
conquestMarks:SetFontSize(fontSize)

	local cMarksValue = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
	cMarksValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 65, 180)
	cMarksValue:SetText("N/A")
	cMarksValue:SetLayer(6)
	cMarksValue:SetFontSize(fontSize)
	
local killsTodayLabel = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
killsTodayLabel:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -36, 210)
killsTodayLabel:SetText("Kills Today:")
killsTodayLabel:SetLayer(6)
killsTodayLabel:SetFontSize(fontSize)

	local killsTodayValue = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
	killsTodayValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 65, 210)
	killsTodayValue:SetText("N/A")
	killsTodayValue:SetLayer(6)
	killsTodayValue:SetFontSize(fontSize)


local prestigeLabel = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
prestigeLabel:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 0, 30)
prestigeLabel:SetText("Prestige 80")
prestigeLabel:SetLayer(6)
prestigeLabel:SetFontSize(28)


local rankXPValue = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
rankXPValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 0, 68)
rankXPValue:SetText("N/A")
rankXPValue:SetLayer(6)
rankXPValue:SetFontSize(fontSize)


	

local FlashMessage = UI.CreateFrame("Text", "EZ", ez.UI.mainWindow)
FlashMessage:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 0, 250)
FlashMessage:SetText("ezPVP")
FlashMessage:SetLayer(5)
FlashMessage:SetFontSize(21)
FlashMessage:SetFontColor(1, 0, 0, 1)


ez.UI.setGoalButton = nkCreateFrame("nkButton", "ez.UI.setGoalButton", ez.UI.mainWindow)
ez.UI.setGoalButton:SetText("SET")
ez.UI.setGoalButton:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -55, 295)
ez.UI.setGoalButton:SetLayer(5)
ez.UI.setGoalButton:SetScale(0.9)


ez.UI.clearGoalButton = nkCreateFrame("nkButton", "ez.UI.clearGoalButton", ez.UI.mainWindow)
ez.UI.clearGoalButton:SetText("CLEAR")
ez.UI.clearGoalButton:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 60, 295)
ez.UI.clearGoalButton:SetLayer(5)
ez.UI.clearGoalButton:SetScale(0.9)

ez.UI.saveGoalButton = nkCreateFrame("nkButton", "ez.UI.saveGoalButton", ez.UI.goalWindow)
ez.UI.saveGoalButton:SetText("SAVE")
ez.UI.saveGoalButton:SetPoint("CENTER", ez.UI.goalWindow, "CENTER", 0, 50)
ez.UI.saveGoalButton:SetLayer(5)
ez.UI.saveGoalButton:SetScale(0.9)


function ez.UI.rescaleUI(size)
	-- Text: favorLabel	favorValue warlordMarks wMarksValue conquestMarks cMarksValue killsTodayLabel killsTodayValue prestigeLabel rankXPValue
	if size == "small" then
	
		ez.UI.mainWindow:SetWidth(200)
		ez.UI.mainWindow:SetHeight(284)
		fontSize = 12
		favorLabel:SetFontSize(fontSize)
		favorLabel:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -35, 100)
		favorValue:SetFontSize(fontSize)
		favorValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 50, 100)
		warlordMarks:SetFontSize(fontSize)
		warlordMarks:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -38, 120)
		wMarksValue:SetFontSize(fontSize)
		wMarksValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 50, 120)
		conquestMarks:SetFontSize(fontSize)
		conquestMarks:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -41, 140)
		cMarksValue:SetFontSize(fontSize)
		cMarksValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 50, 140)
		killsTodayLabel:SetFontSize(fontSize)
		killsTodayLabel:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -27, 160)
		killsTodayValue:SetFontSize(fontSize)
		killsTodayValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 50, 160)
		prestigeLabel:SetFontSize(20)
		rankXPValue:SetFontSize(fontSize)
		ez.UI.setGoalButton:SetScale(0.7)
		ez.UI.clearGoalButton:SetScale(0.7)
		
		ez.UI.clearGoalButton:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 48, 230)
		ez.UI.setGoalButton:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -45, 230)
		FlashMessage:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 0, 185)
		
	elseif size == "default" then
	
		ez.UI.mainWindow:SetWidth(250)
		ez.UI.mainWindow:SetHeight(355)
		
		fontSize = 14
		favorLabel:SetFontSize(fontSize)
		favorLabel:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -41, 120)
		favorValue:SetFontSize(fontSize)
		favorValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 65, 120)
		warlordMarks:SetFontSize(fontSize)
		warlordMarks:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -45, 150)
		wMarksValue:SetFontSize(fontSize)
		wMarksValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 65, 150)
		conquestMarks:SetFontSize(fontSize)
		conquestMarks:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -50, 180)
		cMarksValue:SetFontSize(fontSize)
		cMarksValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 65, 180)
		killsTodayLabel:SetFontSize(fontSize)
		killsTodayLabel:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -36, 210)
		killsTodayValue:SetFontSize(fontSize)
		killsTodayValue:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 65, 210)
		prestigeLabel:SetFontSize(28)
		rankXPValue:SetFontSize(fontSize)
		ez.UI.setGoalButton:SetScale(0.9)
		ez.UI.clearGoalButton:SetScale(0.9)
		ez.UI.clearGoalButton:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 60, 295)
		ez.UI.setGoalButton:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", -55, 295)
		FlashMessage:SetPoint("TOPCENTER", ez.UI.mainWindow, "TOPCENTER", 0, 250)
	else
	
		print("large")
		
	end

end

Command.Event.Attach(EnKai.events['ez.UI.saveGoalButton'].Clicked, function () 

	temp = textField:GetText()
	
	if temp and tonumber(temp) and current_favor < tonumber(temp) then
		print("A goal of: "..temp.." has been set")
		goal = tonumber(temp)
		ez.UI.goalWindow:SetVisible(false)
		requireUpdate = true
	else
		print("Goal Set Error: You must enter a number larger than the amount of favor you currently have.")
		goal = false
	end
	
end,"ez.UI.setGoalButton.Clicked")

Command.Event.Attach(EnKai.events['ez.UI.setGoalButton'].Clicked, function () 
	
	ez.UI.goalWindow:SetVisible(true)

end,"ez.UI.setGoalButton.Clicked")
	

Command.Event.Attach(EnKai.events['ez.UI.clearGoalButton'].Clicked, function () 
	
	print("The goal that was set has now been cleared.")
	goal = false

end,"ez.UI.clearGoalButton.Clicked")
function StatusAnimate()
	if (os.time() - FlashMessageTime) > 4 then
		local alpha = FlashMessage:GetAlpha();
		if (alpha ~= 0) then FlashMessage:SetAlpha(alpha - .05); end
		if (aplha == 0) then FlashMessage:Hide(); end
	end
  
	if requireUpdate then
		requireUpdate = false
		SetValues()
	end
end
 
function FlashMessageSet(message)
  FlashMessage:SetText(message);
  FlashMessage:SetAlpha(1);
  FlashMessageTime = os.time();
end

function SetValues()
	for k,v in pairs(Inspect.Currency.Detail(Inspect.Currency.List())) do
    	local category = Inspect.Currency.Category.Detail(v.category).name
		if v.name == "Favor" then
			if current_favor == nil then current_favor = math.floor(v.stack)
			else
			
				if current_favor < math.floor(v.stack) then
					diff = (math.floor(v.stack)-current_favor)
					FlashMessage:SetFontColor(0, 1, 0, 1)
					FlashMessageSet("+"..diff.." Favor!")
					current_favor = math.floor(v.stack)
				end
				
				if current_favor > math.floor(v.stack) then
					diff = (current_favor-math.floor(v.stack))
					FlashMessage:SetFontColor(1, 0, 0, 1)
					FlashMessageSet("-"..diff.." Favor!")
					current_favor = math.floor(v.stack)
				end
			
			end
			
			if v.stack > 10000 then
				if goal and v.stack < goal then
					favorValue:SetText(comma_value(v.stack, 2).."/"..comma_value(goal, 2))
				elseif goal and v.stack >= goal then
					-- celebrate
					print("Your goal of: "..goal.." has been achieved! Well Done!")
					goal = false
					FlashMessageSet("Well Done!")
					favorValue:SetText(comma_value(v.stack, 2).."")
				else
					favorValue:SetText(comma_value(v.stack, 2).."")
				end
			else
				if goal and v.stack >= goal then
					favorValue:SetText(comma_value(v.stack).."")
					print("Your goal of: "..goal.." has been achieved! Well Done!")
					goal = false
				else
					favorValue:SetText(comma_value(v.stack).."")
				end
			end
		end
		
		if v.name == "Warlord's Mark" then
			wMarksValue:SetText(comma_value(v.stack).."")
		end
		
		if v.name == "Warlord's Mark of Conquest" then
			cMarksValue:SetText(comma_value(v.stack).."")
		end
	end	
	
end

function comma_value(amount, formatType)
  local formatted = amount
  if formatType == nil then formatType = 1 end
  while true do  
	if formatType == 1 then
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
	else
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1k')
	end
    if (k==0) then
      break
    end
  end
  return formatted
end

local function AttachDragFrame(parent, name, layer, button)

	if not name then name = "" end
	if not layer then layer = 0 end
	if not button then button = "LeftDown" end
	
	local DragFrame = UI.CreateFrame("Frame", name.."_DragFrame", parent)
	DragFrame:SetPoint("TOPLEFT", parent, "TOPLEFT")
	DragFrame:SetPoint("BOTTOMRIGHT", parent, "BOTTOMRIGHT")
	DragFrame.parent = parent
	DragFrame.MouseDown = false
	DragFrame:SetLayer(layer)
	
	if button == "LeftDown" then
		function DragFrame.Event:LeftDown()
			self.MouseDown = true
			mouseData = Inspect.Mouse()
			self.MyStartX = self.parent:GetLeft()
			self.MyStartY = self.parent:GetTop()
			self.StartX = mouseData.x - self.MyStartX
			self.StartY = mouseData.y - self.MyStartY
			tempX = self.parent:GetLeft()
			tempY = self.parent:GetTop()
			tempW = self.parent:GetWidth()
			tempH =	self.parent:GetHeight()
			self.parent:ClearAll()
			self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", tempX, tempY)
			self.parent:SetWidth(tempW)
			self.parent:SetHeight(tempH)
		end
		function DragFrame.Event:MouseMove(mouseX, mouseY)
			if self.MouseDown then
				self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", (mouseX - self.StartX), (mouseY - self.StartY))
			end
		end
		function DragFrame.Event:LeftUp()
			if self.MouseDown then
				self.MouseDown = false
			end
		end
	elseif button == "RightDown" then
		function DragFrame.Event:RightDown()
			self.MouseDown = true
			mouseData = Inspect.Mouse()
			self.MyStartX = self.parent:GetLeft()
			self.MyStartY = self.parent:GetTop()
			self.StartX = mouseData.x - self.MyStartX
			self.StartY = mouseData.y - self.MyStartY
			tempX = self.parent:GetLeft()
			tempY = self.parent:GetTop()
			tempW = self.parent:GetWidth()
			tempH =	self.parent:GetHeight()
			self.parent:ClearAll()
			self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", tempX, tempY)
			self.parent:SetWidth(tempW)
			self.parent:SetHeight(tempH)
		end
		function DragFrame.Event:MouseMove(mouseX, mouseY)
			if self.MouseDown then
				self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", (mouseX - self.StartX), (mouseY - self.StartY))
			end
		end
		function DragFrame.Event:RightUp()
			if self.MouseDown then
				self.MouseDown = false
			end
		end

	end
	
	return DragFrame
end

local mapicon = AttachDragFrame(minimapIcon, "MapIcon", 10, "RightDown")
mapicon:SetVisible(true)

local function InitAddon(h, addon)
	if addon == "ezPvP" then
		Command.Console.Display("general", false, "<font color=\"#FFFF00\">ezPvP "..addonInfo.toc.Version.." Loaded.</font>", true)
	end
end

function slash_ezpvp(handle, parameters)

	if (parameters == 'toggle') then
	
		if (toggle_state == 1) then
			toggle_state = 0
			ez.UI.mainWindow:SetVisible(false)
			ez.UI.inputWindow:SetVisible(false)
			Command.Console.Display("general", false, "ezPvP window has been hidden.", true)
		else
			toggle_state = 1
			ez.UI.mainWindow:SetVisible(true)
			Command.Console.Display("general", false, "ezPvP window is now showing.", true)
		end
	elseif (parameters == 'author') then
		Command.Console.Display("general", false, "<font color=\"#FFFF00\">This simple addon was created by Zanderwar@Wolfsbane!</font>", true)
	else
		Command.Console.Display("general", false, "<font color=\"#00FF00\">Command List: (usage: /ezpvp [parameters])</font>", true)
		Command.Console.Display("general", false, "<font color=\"#00FF00\">- '<i>toggle</i>': Will show or hide the window.</font>", true)
		Command.Console.Display("general", false, "<font color=\"#00FF00\">- '<i>author</i>': Information about the author.</font>", true)
	end
	

end

local function SaveVariables(handle, addon)
	if addon == "ezPvP" then
		framePosX = math.floor(ez.UI.mainWindow:GetLeft())
		framePosY = math.floor(ez.UI.mainWindow:GetTop())
		iconX = math.floor(minimapIcon:GetLeft())
		iconY = math.floor(minimapIcon:GetTop())
		ezScale = math.floor(tonumber(ez.UI.scaleSlider:GetPosition()))
		if goal then favorGoal = tonumber(goal) else
			favorGoal = false
		end
	end
end

local function InitVariables(handle, addon)
	if addon == "ezPvP" then
		local frameX = 350
		local frameY = 350
		local mapIconX = 400
		local mapIconY = 400
		
		if framePosX then
			frameX = framePosX
		end
		
		if framePosY then
			frameY = framePosY
		end
		
		if iconX then
			mapIconX = iconX
		end
		
		if iconY then
			mapIconY = iconY
		end

		
		ez.UI.mainWindow:SetPoint("TOPLEFT", UIParent, "TOPLEFT", frameX, frameY)
		minimapIcon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", mapIconX, mapIconY)
		
		if ezScale then 
			if ezScale == 1 then
				ez.UI.scaleSlider:SetPosition(1)
				ez.UI.rescaleUI("small")
			else
				ez.UI.scaleSlider:SetPosition(2)
				ez.UI.rescaleUI("default")
			end
		else
			ez.UI.scaleSlider:SetPosition(2)
		end
		if favorGoal then goal = favorGoal end
	end
end

mapicon:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
	if ez.UI.mainWindow:GetVisible() then
		toggle_state = 0
		ez.UI.mainWindow:SetVisible(false)
		ez.UI.dropDown:SetVisible(false)
		ez.UI.goalWindow:SetVisible(false)
		Command.Console.Display("general", false, "ezPvP window has been hidden.", true)
	else
		toggle_state = 1
		ez.UI.mainWindow:SetVisible(true)
		Command.Console.Display("general", false, "ezPvP window is now showing.", true)
	end
end, "Event.UI.Input.Mouse.Left.Down")

local function PrestigeAccumulated()

	prestige = Inspect.Pvp.Prestige()
	history = Inspect.Pvp.History()
	
	
	if prestige and history then 
		prestigeLabel:SetText("Prestige "..prestige.rank)
		rankXPValue:SetText("XP:"..comma_value(math.floor(prestige.accumulated)).."/"..comma_value(prestige.needed))
		killsTodayValue:SetText(history.killToday.."")
	end

end

local function unitReady(unit)
	if unit then
		for k,v in pairs(unit) do
			if v == "player" then
				if Inspect.Unit.Detail("player").level >= 50 then
					PrestigeAccumulated()
				else
				
					prestigeLabel:SetText("ezPvP")
					rankXPValue:SetText("Version "..addonInfo.toc.Version)
				
				end
				
			end
		end
	end
end

SetValues()
Command.Event.Attach(Event.Currency, SetValues, "Event.Currency")
Command.Event.Attach(Event.Pvp.Prestige.Accumulated, PrestigeAccumulated, "Event.Pvp.Prestige.Accumulated")
table.insert(Event.Unit.Availability.Full, {unitReady, "ezPvP", "Check if player unit is ready"})
Command.Event.Attach(Event.Pvp.Prestige.Rank, PrestigeAccumulated, "Event.Pvp.Prestige.Rank")
Command.Event.Attach(Event.Addon.Load.End, InitAddon, "Init zone tables")
Command.Event.Attach(Command.Slash.Register("ezpvp"), slash_ezpvp, "Slash command")
Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, SaveVariables, "SaveVariables")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, InitVariables, "InitVariables")
table.insert(Event.System.Update.Begin, {StatusAnimate, "ezPvP", "Animate the status text"})